//wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww/** I N C L U D E S **********************************************************/ 
#include <p18f4580.h> 
#include <delays.h>                        
#include <timers.h>
#include <string.h>
#include <adc.h>
#include"LCD\\xlcd.h"
#include"LCD 4x40\\xlcd2.h"





#pragma config OSC = IRCIO7			//Internal RC with OSC1 as RA7 and OSC2 as divide by 4 clock out
#pragma config FCMENB = OFF			//Fail-safe clock monitor disabled
#pragma config IESOB = OFF			//Internal OSC switch over bit
#pragma config PWRT = ON			//Power up timer ON
#pragma config BOR = BOACTIVE		//enabled whenever part is active, SBOREN disabled
#pragma config BORV = 42			//Reset if Vcc smaller 4,2V; 2,7V; 2,0V 
#pragma config WDT = ON				//Watchdog ON
#pragma config WDTPS = 4096			//after 16,384 s reset
#pragma config PBADEN = ON			//Pins are configured as analog input channels on Reset
#pragma config LPT1OSC = OFF		//bei 0; Timer1 configured for higher power operation
#pragma config MCLRE = ON			//Reset at MCLR ON
#pragma config LVP = OFF			//LVP OFF	


//-------------------------------------------------------------------------------------------------------------------- 

#define TEST_LED	 		LATBbits.LATB0		// output

void InterruptHandlerHigh (void);
void InterruptHandlerLow (void);

volatile unsigned char sec = 0;
volatile unsigned char minute = 0;
volatile int stunde = 0;

volatile unsigned char P_sec = 10;
volatile unsigned char P_minute = 20;
volatile int P_stunde = 30;


volatile unsigned short AN0;						//0 -> 655xx
int temp1;
float Temperatur;

unsigned char delayADC = 100;    					//0 bis 255 DELAY ADC Messung

void DelayFor18TCY( void )
{
 int i_18;
 for( i_18=0;i_18<36;i_18++ )
 {
   Nop();
 }
} 
//---------------------------------------------------------
void DelayPORXLCD( void )
{
Delay1KTCYx(200); //Delay of 15ms 
return;
}
//---------------------------------------------------------
void DelayXLCD( void )
{
Delay1KTCYx(100); //Delay of 5ms //10
return;
}
//---------------------------------------------------------

void main(void) 
{ 

char LCDdata1[8];					// Zeichen erste Zeile 8
char LCDdata1_1[8];					// Zeichen erste Zeile 8
char LCDdata2[11];					// Zeichen zweite Zeile 6
char LCDdata3[11];					// Zeichen zweite Zeile 6




					

OSCCONbits.IRCF2 = 1;							// IRCF<2:0>: Internal Oscillator Frequency Select bits
OSCCONbits.IRCF1 = 1;							// 111 = 8 MHz (INTOSC drives clock directly)
OSCCONbits.IRCF0 = 1;							// 110 = 4 MHz
												// 101 = 2 MHz
												// 100 = 1 MHz(3)
												// 011 = 500 kHz
												// 010 = 250 kHz
												// 001 = 125 kHz
												// 000 = 31 kHz (from either INTOSC/256 or INTRC directly)(2)

OSCCONbits.SCS1	= 0;							// SCS<1:0>: System Clock Select bits    00 fr PLL
OSCCONbits.SCS0	= 0;							// 1x = Internal oscillator block
												// 01 = Timer1 oscillator
												// 00 = Primary oscillator


OSCTUNEbits.PLLEN = 0;							// PLLEN: Frequency Multiplier PLL for INTOSC Enable bit(1)
												// 1 = PLL enabled for INTOSC (4 MHz and 8 MHz only)
												// 0 = PLL disabled

//--------------------------------------------------------------------------------------------------------------//


//--------------------------------------------------------------------------------------------------------------//

TRISBbits.TRISB0 = 0; 								// set PORTB0 as output port     


//--------------------------------------------------------------------------------------------------------------//


//--------------------------------------------------------------------------------------------------------------//
//Timer 0	1,953 kHz High priority interrupt routine
										

T0CONbits.T0PS2 = 0;								// T0PS<2:0>: Timer0 Prescaler Select bits
T0CONbits.T0PS1 = 1;								// 111 = 1:256 Prescale value
T0CONbits.T0PS0 = 1;								// 110 = 1:128 Prescale value
													// 101 = 1:64 Prescale value
													// 100 = 1:32 Prescale value
													// 011 = 1:16 Prescale value
													// 010 = 1:8 Prescale value
													// 001 = 1:4 Prescale value
													// 000 = 1:2 Prescale value

T0CONbits.T0PS3 = 0;								// PSA: Timer0 Prescaler Assignment bit .PSA laut Datenblatt geht nicht!!
													// 1 = TImer0 prescaler is not assigned. Timer0 clock input bypasses prescaler.  if 1 = prescaler not working and 1:2 ratio
													// 0 = Timer0 prescaler is assigned. Timer0 clock input comes from prescaler output.

T0CONbits.T0SE = 1;									// T0SE: Timer0 Source Edge Select bit
													// 1 = Increment on high-to-low transition on T0CKI pin
													// 0 = Increment on low-to-high transition on T0CKI pin

T0CONbits.T0CS = 0;									// T0CS: Timer0 Clock Source Select bit
													// 1 = Transition on T0CKI pin input edge
													// 0 = Internal clock (FOSC/4)

T0CONbits.T08BIT = 1;								//0= 16bit Timer  1= 8bit Timer
T0CONbits.TMR0ON = 1;								//1= enable Timer	0

INTCONbits.TMR0IE = 1;								//TMR0 Overflow Interrupt Enable bit
													//1 = Enables the TMR0 overflow interrupt

INTCON2bits.TMR0IP =1;     							//TMR0 Overflow Interrupt Priority bit for RTC
													//1 = High priority
													//0 = Low priority
//-----------------------------------------------------------------------------------------------------------------//
//Timer1 @  low priority interrupt 15,26 Hz

T1CONbits.RD16 = 1;									//1 = Enables register read/write of TImer1 in one 16-bit operation
T1CONbits.T1RUN = 1;								//1 = Device clock is derived from Timer1 oscillator
T1CONbits.T1CKPS1 = 1;								//Prescale 	1=8		1=4			0=1
T1CONbits.T1CKPS0 = 1;								//Prescale 	1=8     0=4			0=1
T1CONbits.T1OSCEN = 1;								//1 = Timer1 oscillator is enabled
T1CONbits.TMR1CS = 0;								//0 = Internal clock (FOSC/4)				
T1CONbits.TMR1ON = 1;								//1 = Enables Timer1

PIE1bits.TMR1IE = 1; 								//TMR1 Overflow Interrupt Enable bit
													//1 = Enables the TMR1 overflow interrupt
IPR1bits.TMR1IP = 0;								//TMR1 Overflow Interrupt Priority bit
													//1 = High priority
													//0 = Low priority

//-----------------------------------------------------------------------------------------------------------------//


//-----------------------------------------------------------------------------------------------------------------//

RCONbits.IPEN = 1;               					//Interrupt Priority Enable bit

													//1 = Enable high priority levels on interrupts
INTCONbits.GIEH = 1;             					//Global Interrupt Enable bit
													//When IPEN = 1:

													//1 = Enables low priority interrupts
INTCONbits.GIEL = 1;								//When IPEN = 1:
													//1 = Enables all low priority peripheral interrupts


//-----------------------------------------------------------------------------------------------------------------//


INTCON2bits.RBPU = 1;								//PORTB Pull-up Enable bit
													//1 = All PORTB pull-ups are disabled
													//0 = PORTB pull-ups are enabled by individual port latch values

//-----------------------------------------------------------------------------------------------------------------//
ADCON0bits.ADON = 1;     							//1 = A/D converter module is enabled 
ADCON0bits.GO = 1;      							//1 = A/D conversion in progress 
ADCON0bits.CHS0 = 0;     							//CHS3:CHS0: Analog Channel Select bits	0000 = Channel 0 (AN0)
ADCON0bits.CHS1 = 0;     							//CHS3:CHS0: Analog Channel Select bits	0000 = Channel 0 (AN0)
ADCON0bits.CHS2 = 0;     							//CHS3:CHS0: Analog Channel Select bits	0000 = Channel 0 (AN0)
ADCON0bits.CHS3 = 0;     							//CHS3:CHS0: Analog Channel Select bits	0000 = Channel 0 (AN0)

													//PCFG3:PCFG0: A/D Port Configuration Control bits:
ADCON1bits.PCFG0 = 0;     							//1110 (AN10) D D D D D D D D D D A	 (AN0) 
ADCON1bits.PCFG1 = 1;     							//1110 (AN10) D D D D D D D D D D A	 (AN0)  
ADCON1bits.PCFG2 = 1;     							//1110 (AN10) D D D D D D D D D D A	 (AN0)  
ADCON1bits.PCFG3 = 1;     							//1110 (AN10) D D D D D D D D D D A	 (AN0)  

ADCON1bits.VCFG0 = 0;     							//0 = AVDD          (AN3) Voltage Reference Configuration bit (VREF+ source)
ADCON1bits.VCFG1 = 0;     							//0 = AVSS			Voltage Reference Configuration bit (VREF- source)
ADCON2bits.ADCS0 = 0;     							//110 = FOSC/64 
ADCON2bits.ADCS1 = 1;     							//110 = FOSC/64 
ADCON2bits.ADCS2 = 1;     							//110 = FOSC/64 
ADCON2bits.ACQT0 = 1;     							//111 = 20 TAD 
ADCON2bits.ACQT1 = 1;     							//111 = 20 TAD 
ADCON2bits.ACQT2 = 1;     							//111 = 20 TAD 
ADCON2bits.ADFM = 1;     							//1 = Right justified 

//-----------------------------------------------------------------------------------------------------------------//

TEST_LED = 0;


OpenXLCD(FOUR_BIT & LINES_5X7 );
while( BusyXLCD() ) { }

Delay10TCYx(20);

OpenXLCD_2(FOUR_BIT & LINES_5X7 );
while( BusyXLCD_2() ) { }






while (1) 
	{ 

	ClrWdt()											// clear Watchdog
//---------------------------------------------------------------------------------------------------------//  	
	SetDDRamAddr((unsigned char) 0); 					// 1. Zeile im Display
  	putrsXLCD(( char*)"Uhrzeit");
  	strcpypgm2ram(LCDdata1, "        ");
	LCDdata1[0] =  (stunde  % 100) / 10 + '0'; 			// Zehnerstelle
	LCDdata1[1] =  stunde  % 10 + '0'; 					// Einnerstelle
	LCDdata1[2] =  ':';
	LCDdata1[3] =  (minute  % 100) / 10 + '0'; 			// Zehnerstelle
	LCDdata1[4] =  minute  % 10 + '0'; 					// Einnerstelle
	LCDdata1[5] =  ':';
	LCDdata1[6] =  (sec  % 100) / 10 + '0'; 			// Zehnerstelle
	LCDdata1[7] =  sec  % 10 + '0'; 					// Einnerstelle
	SetDDRamAddr((unsigned char) 10); 					// 1. Zeile im Display
 	Delay10TCYx(20);
  	putsXLCD( LCDdata1);


	SetDDRamAddr((unsigned char) 19); 					// 1. Zeile im Display
  	putrsXLCD(( char*)"Restpumpzeit");
  	strcpypgm2ram(LCDdata1, "        ");
	LCDdata1_1[0] =  (P_stunde  % 100) / 10 + '0'; 		// Zehnerstelle
	LCDdata1_1[1] =  P_stunde  % 10 + '0'; 				// Einnerstelle
	LCDdata1_1[2] =  ':';
	LCDdata1_1[3] =  (P_minute  % 100) / 10 + '0'; 		// Zehnerstelle
	LCDdata1_1[4] =  P_minute  % 10 + '0'; 				// Einnerstelle
	LCDdata1_1[5] =  ':';
	LCDdata1_1[6] =  (P_sec  % 100) / 10 + '0'; 		// Zehnerstelle
	LCDdata1_1[7] =  P_sec  % 10 + '0'; 				// Einnerstelle
	SetDDRamAddr((unsigned char) 32); 					// 1. Zeile im Display
 	Delay10TCYx(20);
  	putsXLCD( LCDdata1_1);

//---------------------------------------------------------------------------------------------------------//  	

 	Delay10TCYx(delayADC); 
	SetChanADC( ADC_CH0);
	Delay10TCYx(delayADC); 
	ConvertADC();
	while( BusyADC() ){}
	AN0 = ReadADC();
	Temperatur = (float) AN0 * 0.23728 - 82.95907;

//---------------------------------------------------------------------------------------------------------//  	

	SetDDRamAddr((unsigned char) 64); 					// 2. Zeile im Display
  	putrsXLCD(( char*)"Wasser IST");

	strcpypgm2ram(LCDdata2, "        ");
	temp1 = (int)Temperatur;
 	LCDdata2[0] =  (int)Temperatur / 10 + '0'; 			// Zehnerstelle
 	LCDdata2[1] =  ((int)Temperatur)  % 10 + '0'; 		// Einnerstelle
 	LCDdata2[2] =  '.';
	LCDdata2[3] =  ((int)(Temperatur*10))  % 10 + '0'; 	// Einnerstelle
	LCDdata2[4] =  0xDF;
	LCDdata2[5] =  'C';
	SetDDRamAddr((unsigned char) 76); 				// 2. Zeile im Display
  	Delay10TCYx(20);
  	putsXLCD( LCDdata2);

	SetDDRamAddr((unsigned char) 83); 					// 2. Zeile im Display
  	putrsXLCD(( char*)"Filterpumpe");
	SetDDRamAddr((unsigned char) 97); 					// 2. Zeile im Display
  	putrsXLCD(( char*)"Inaktiv");

//---------------------------------------------------------------------------------------------------------// 

	SetDDRamAddr_2((unsigned char) 0); 					// 3. Zeile im Display
  	putrsXLCD_2("Wasser Soll");

	strcpypgm2ram(LCDdata3, "        ");
 	LCDdata3[0] =  (int)Temperatur / 10 + '0'; 			// Zehnerstelle
 	LCDdata3[1] =  ((int)Temperatur)  % 10 + '0'; 		// Einnerstelle
 	LCDdata3[2] =  0xDF;
	LCDdata3[3] =  'C';
	SetDDRamAddr_2((unsigned char) 14); 				// 3. Zeile im Display
  	Delay10TCYx(20);
  	putsXLCD_2( LCDdata3);

	SetDDRamAddr_2((unsigned char) 19); 				// 2. Zeile im Display
  	putsXLCD_2("Erwrmung");
	SetDDRamAddr_2((unsigned char) 33); 				// 3. Zeile im Display
  	putsXLCD_2("Inaktiv");


//---------------------------------------------------------------------------------------------------------// 

	}	

}


//--------------------------------------------------------------------------------------------------------// 
// High priority interrupt vector 
#pragma code InterruptVectorHigh = 0x08 
void 
InterruptVectorHigh (void) 
{ 
_asm 
   goto InterruptHandlerHigh 																	//jump to interrupt routine 
_endasm 
} 
//--------------------------------------------------------------------------------------------------------// 
// High priority interrupt routine 1,9xx kHz
#pragma code 
#pragma interrupt InterruptHandlerHigh 


void 
InterruptHandlerHigh () 
{ 

		
if (INTCONbits.TMR0IF) 
   			{
			INTCONbits.GIEH = 0;                           									//disable interrupts   
			INTCONbits.TMR0IF = 0;  			     										//clear interrupt flag 

			
 


			INTCONbits.TMR0IE = 1; 				//Enables the TMR0 overflow interrupt
			INTCONbits.GIEH = 1;  	            //enable interrupts
			} 	

}

 
//--------------------------------------------------------------------------------------------------------// 
// Low priority interrupt vector 
#pragma code InterruptVectorLow = 0x18 
void 
InterruptVectorLow (void) 
{ 
_asm 
   goto InterruptHandlerLow 				//jump to interrupt routine 
_endasm 
} 
//--------------------------------------------------------------------------------------------------------// 
// Low priority interrupt routine 
#pragma code 
#pragma interrupt InterruptHandlerLow 


void 
InterruptHandlerLow () 
{ 

	if (PIR1bits.TMR1IF) 
			{

			PIR1bits.TMR1IF = 0;				//clear interrupt flag 
			TEST_LED = !TEST_LED;

       		 	if ( sec<59 )
        		{
            	sec++;
        		}
        		else
        			{
            		sec=0;
            		if ( minute<59 )
            			{
                		minute++;
            			}
						else
    			        {
                		minute= 0;
                		if (stunde<23 )
                			{
                    		stunde++;
               				}
                		else
               			 		{
                   		 		stunde = 0;
								}

						}
					}



			}
		

}
